=== tests/utests/CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,6 @@
     ${CMAKE_CURRENT_SOURCE_DIR}/data/*.c
     ${CMAKE_CURRENT_SOURCE_DIR}/extensions/*.c
     ${CMAKE_CURRENT_SOURCE_DIR}/schema/*.c
-    ${CMAKE_CURRENT_SOURCE_DIR}/schema/*.h
     ${CMAKE_CURRENT_SOURCE_DIR}/types/*.c
     ${CMAKE_CURRENT_SOURCE_DIR}/restriction/*.c
     ${CMAKE_CURRENT_SOURCE_DIR}/node/*.c
@@ -29,6 +28,7 @@
 ly_add_utest(NAME yang_types   SOURCES types/yang_types.c)
 ly_add_utest(NAME enumeration  SOURCES types/enumeration.c)
 ly_add_utest(NAME instanceid   SOURCES types/instanceid.c)
+ly_add_utest(NAME instanceid_keys   SOURCES types/instanceid_keys.c)
 ly_add_utest(NAME union        SOURCES types/union.c)
 ly_add_utest(NAME boolean      SOURCES types/boolean.c)
 ly_add_utest(NAME decimal64    SOURCES types/decimal64.c)
@@ -46,19 +46,19 @@
 ly_add_utest(NAME hash_table SOURCES basic/test_hash_table.c)
 ly_add_utest(NAME inout SOURCES basic/test_inout.c)
 ly_add_utest(NAME context SOURCES basic/test_context.c)
+if(NOT WIN32)
 ly_add_utest(NAME plugins SOURCES basic/test_plugins.c)
+endif()
 ly_add_utest(NAME xml SOURCES basic/test_xml.c)
 ly_add_utest(NAME json SOURCES basic/test_json.c)
 ly_add_utest(NAME xpath SOURCES basic/test_xpath.c)
 ly_add_utest(NAME yanglib SOURCES basic/test_yanglib.c)
 
-ly_add_utest(NAME schema SOURCES schema/test_schema.c schema/test_schema_common.c schema/test_schema_stmts.c schema/test_schema_extensions.c)
-ly_add_utest(NAME parser_yang SOURCES schema/test_parser_yang.c)
-ly_add_utest(NAME parser_yin SOURCES schema/test_parser_yin.c)
+ly_add_utest(NAME schema SOURCES schema/test_schema.c)
+ly_add_utest(NAME yang SOURCES schema/test_yang.c)
+ly_add_utest(NAME yin SOURCES schema/test_yin.c)
 ly_add_utest(NAME tree_schema_compile SOURCES schema/test_tree_schema_compile.c)
 ly_add_utest(NAME printer_tree SOURCES schema/test_printer_tree.c)
-ly_add_utest(NAME printer_yang SOURCES schema/test_printer_yang.c)
-ly_add_utest(NAME printer_yin SOURCES schema/test_printer_yin.c)
 
 ly_add_utest(NAME tree_data SOURCES data/test_tree_data.c)
 ly_add_utest(NAME new SOURCES data/test_new.c)
@@ -73,3 +73,5 @@
 ly_add_utest(NAME metadata SOURCES extensions/test_metadata.c)
 ly_add_utest(NAME nacm SOURCES extensions/test_nacm.c)
 ly_add_utest(NAME yangdata SOURCES extensions/test_yangdata.c)
+ly_add_utest(NAME schema_mount SOURCES extensions/test_schema_mount.c)
+ly_add_utest(NAME structure SOURCES extensions/test_structure.c)
