=== debian/changelog ===
libyang2 (2.1.30-2.1ubuntu0.1) noble-security; urgency=medium

  * SECURITY UPDATE: NULL pointer deref in lys_parse_mem
    - debian/patches/CVE-2023-26916.patch: schema compile UPDATE do not
      implement 2 same modules in src/schema_compile.c.
    - CVE-2023-26916
  * SECURITY UPDATE: NULL pointer deref in lysp_stmt_validate_value
    - debian/patches/CVE-2023-26917.patch: parser common BUGFIX handle
      missing YANG strings in src/parser_common.c.
    - CVE-2023-26917

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Fri, 12 Sep 2025 12:40:50 -0400

libyang2 (2.1.30-2.1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 02:22:15 +0000

libyang2 (2.1.30-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062738

 -- Steve Langasek <vorlon@debian.org>  Fri, 01 Mar 2024 07:25:05 +0000

libyang2 (2.1.30-2) unstable; urgency=medium

  * Non-maintainer upload.
  * d/t/{control,yangre}: add a DEP8 test for yangre.

 -- Utkarsh Gupta <utkarsh@debian.org>  Wed, 01 Feb 2023 14:44:51 +0530

libyang2 (2.1.30-1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release.
    + Fixes a bug and test suite failure on big endian architectures.

 -- Marco d'Itri <md@linux.it>  Wed, 18 Jan 2023 15:41:16 +0100

libyang2 (2.1.4-2) unstable; urgency=medium

  * Non-maintainer upload.
  * Backported the upstream commit 118eb52 to fix a bug and test suite
    failure on big endian architectures.

 -- Marco d'Itri <md@linux.it>  Fri, 13 Jan 2023 03:20:45 +0100

libyang2 (2.1.4-1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release. (Closes: #1023794)
  * Enable the build time tests. (Closes: #1004191)

 -- Marco d'Itri <md@linux.it>  Fri, 06 Jan 2023 18:40:33 +0100
