=== debian/control ===
--- 
+++ 
@@ -5,15 +5,18 @@
 XSBC-Original-Maintainer: Ondřej Surý <ondrej@debian.org>
 Priority: optional
 Standards-Version: 4.5.0
-Build-Depends: cmake,
-               debhelper (>= 10),
+Build-Depends: dpkg-dev (>= 1.22.5), cmake,
+               debhelper-compat (= 13),
                libcmocka-dev <!nocheck>,
                libpcre2-dev,
                pkg-config
-Vcs-Browser: https://github.com/CESNET/libyang/tree/libyang2
-Vcs-Git: https://github.com/CESNET/libyang.git -b libyang2
+Vcs-Browser: https://salsa.debian.org/netconf-team/libyang2
+Vcs-Git: https://salsa.debian.org/netconf-team/libyang2.git -b debian/master
 
-Package: libyang2
+Package: libyang2t64
+Provides: ${t64:Provides}
+Replaces: libyang2
+Breaks: libyang2 (<< ${source:Version})
 Depends: ${misc:Depends},
          ${shlibs:Depends}
 Architecture: any
@@ -32,7 +35,7 @@
 
 Package: libyang2-dev
 Depends: libpcre2-dev,
-         libyang2 (= ${binary:Version}),
+         libyang2t64 (= ${binary:Version}),
          ${misc:Depends}
 Conflicts: libyang-dev
 Section: libdevel
@@ -51,7 +54,7 @@
  for libyang.
 
 Package: libyang2-tools
-Depends: libyang2 (= ${binary:Version}),
+Depends: libyang2t64 (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends}
 Breaks: libyang-tools (<< ${source:Version})
